Index: orxonox/branches/buerli/gui/orxonox_gui_exec.cc
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_exec.cc	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui_exec.cc	(revision 2707)
@@ -38,4 +38,5 @@
   execFrame = new Frame ("Execute-Tags:");
   execBox = new Box ('v');
+  execFrame->setGroupName ("misc");
   
   start = new Button ("Start");
@@ -109,5 +110,5 @@
   CONFIG_FILE = fopen (configFile, "w");
   if (CONFIG_FILE)
-    writeFileText (widget);
+    writeFileText (widget, 0);
   fclose (CONFIG_FILE);
 }
@@ -116,7 +117,34 @@
    \brief Actually writes into the configuration file to the disk.
    \param widget from which Widget on should be saved.
-*/
-void OrxonoxGuiExec::writeFileText (Widget* widget)
-{
+   \param depth initially "0", and grows higher, while new Groups are bundeled.
+*/
+void OrxonoxGuiExec::writeFileText (Widget* widget, int depth)
+{
+  int counter = 0;
+  while (counter < depth && ((widget->is_option>0
+			      && (strcmp (static_cast<Option*>(widget)->flag_name, "")
+				  || strcmp (static_cast<Option*>(widget)->flag_name_short, "")) )
+			     || (widget->is_option<0
+				 && strcmp (static_cast<Packer*>(widget)->getGroupName(), ""))))
+    {
+      fprintf (CONFIG_FILE, "  ", depth);
+      counter++;
+    }
+  
+  // check if it is a Packer, and if it is, check if it has a name and if there is something in it.
+  if (widget->is_option <0)
+    {
+      if (strcmp (static_cast<Packer*>(widget)->getGroupName(), ""))
+	{
+	  fprintf (CONFIG_FILE, "[%s]\n", static_cast<Packer*>(widget)->getGroupName());
+	  writeFileText (static_cast<Packer*>(widget)->down, depth+1);
+	  fprintf(CONFIG_FILE, "\n");
+	}
+      else
+	{
+	  writeFileText (static_cast<Packer*>(widget)->down, depth);
+	}
+    } 
+  
   if (widget->is_option >= 1)
     if  (strcmp (static_cast<Option*>(widget)->flag_name, "") || strcmp (static_cast<Option*>(widget)->flag_name_short, ""))
@@ -124,7 +152,7 @@
 	char Buffer[256];
 	char* space2under;
-	sprintf (Buffer, "%s", static_cast<Option*>(widget)->option_name);
+	sprintf (Buffer, "%s", static_cast<Option*>(widget)->label);
 	if (strchr (Buffer, '_'))
-	  cout << "Warning Optionname" << Buffer << " is not Valid for Saving, because it includes an underscore" << endl; 
+	  cout << "Warning Optionname" << Buffer << " is not Valid for Saving, because it includes an underscore" << endl;
 	while (space2under = strchr(Buffer, ' '))
 	  {
@@ -133,16 +161,7 @@
 	fprintf (CONFIG_FILE, "%s = %i\n", Buffer, static_cast<Option*>(widget)->value);
       }
-  switch (widget->is_option)
-    {
-    case -1:
-      writeFileText (static_cast<Container*>(widget)->down);
-      break;
-    case -2:
-      writeFileText (static_cast<Box*>(widget)->down);
-      break;
-    } 
-  
+
   if (widget->next != NULL)
-    writeFileText (widget->next);
+    writeFileText (widget->next, depth);
 }
 
@@ -156,4 +175,5 @@
   if (CONFIG_FILE)
     {
+      Widget* groupWidget = widget;
       char Buffer[256] = "";
       char Variable[256]= "";
@@ -161,4 +181,12 @@
       while (fscanf (CONFIG_FILE, "%s", Buffer) != EOF)
 	{
+	  if (!strncmp (Buffer, "[", 1))
+	    {
+	      if ((groupWidget = locateGroup (widget, Buffer, 1))==NULL)
+		{
+		  cout << "!!There is no group called " << Buffer << " in this GUI.\n First best Widget will get the Infos assigned.\n Config-File will be updated in next Save\n";
+		  groupWidget = widget;
+		}
+	    }
 	  if (!strcmp (Buffer, "="))
 	    {
@@ -171,5 +199,5 @@
 	      fscanf (CONFIG_FILE, "%s", Buffer);
 	      Value = atoi(Buffer);
-	      readFileText (widget, Variable, Value);
+	      readFileText (groupWidget, Variable, Value, 0);
 	      sprintf (Variable, "");
 	    }
@@ -179,5 +207,4 @@
     }
 }
-
 /**
    \brief Maps Confugurations to the Options.
@@ -185,23 +212,54 @@
    \param variableName the name of the Variable that should be set up.
    \param variableValue the Value of the Variable that should be set up
-*/
-void OrxonoxGuiExec::readFileText (Widget* widget, char* variableName, int variableValue)
+   \param depth the depth of the local Widget
+*/
+void OrxonoxGuiExec::readFileText (Widget* widget, char* variableName, int variableValue, int depth)
 {
   if (widget->is_option >= 1)
-    if (!strcmp (static_cast<Option*>(widget)->option_name, variableName))
+    if (!strcmp (static_cast<Option*>(widget)->label, variableName))
 	static_cast<Option*>(widget)->value = variableValue;
 
-  switch (widget->is_option)
-    {
-    case -1:
-      readFileText (static_cast<Container*>(widget)->down, variableName, variableValue);
-      break;
-    case -2:
-      readFileText (static_cast<Box*>(widget)->down, variableName, variableValue);
-      break;
+  if (widget->is_option < 0)
+    {
+      readFileText (static_cast<Packer*>(widget)->down, variableName, variableValue, depth+1);
     } 
 
-  if (widget->next != NULL)
-    readFileText (widget->next, variableName, variableValue);
+  if (widget->next != NULL && depth !=0)
+    readFileText (widget->next, variableName, variableValue, depth);
+}
+
+/**
+   \brief locates a Group member
+*/
+Widget* OrxonoxGuiExec::locateGroup(Widget* widget, char* groupName, int depth)
+{
+  Widget* tmp;
+
+  // removes the trailing and ending [ ].
+  if (!strncmp (groupName, "[", 1))
+    {
+      groupName = groupName+1;
+      groupName[strlen(groupName)-1] = '\0';
+    }
+
+  if (widget->is_option < 0)
+    {
+      if (!strcmp(groupName, static_cast<Packer*>(widget)->getGroupName()))
+	{
+	  return widget;
+	}
+      else
+	{
+	  if ((tmp = locateGroup (static_cast<Packer*>(widget)->down, groupName, depth+1)) != NULL)
+	    return tmp;
+	}
+    } 
+  
+  if (widget->next != NULL && depth != 0)
+    {
+      if ((tmp = locateGroup (widget->next, groupName, depth)) != NULL)
+	return tmp;
+    }
+  return NULL;
 }
 
Index: orxonox/branches/buerli/gui/orxonox_gui_exec.h
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_exec.h	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui_exec.h	(revision 2707)
@@ -33,7 +33,8 @@
   int shouldsave ();
   void writeToFile (Widget* widget);
-  void writeFileText (Widget* widget);
+  void writeFileText (Widget* widget, int depth);
   void readFromFile (Widget* widget);
-  void readFileText (Widget* widget, char* variableName, int variableValue);
+  void readFileText (Widget* widget, char* variableName, int variableValue, int depth);
+  Widget* locateGroup(Widget* widget, char* groupName, int depth);
 
 };
Index: orxonox/branches/buerli/gui/orxonox_gui_flags.cc
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_flags.cc	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui_flags.cc	(revision 2707)
@@ -39,4 +39,5 @@
 
   flagsLabel = new Label ();
+  flagsLabel->setSize (260,60);
   flagsBox->fill (flagsLabel);
   shortFlags = new CheckButton ("shortFlags");
Index: orxonox/branches/buerli/gui/orxonox_gui_keys.cc
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_keys.cc	(revision 2707)
+++ orxonox/branches/buerli/gui/orxonox_gui_keys.cc	(revision 2707)
@@ -0,0 +1,77 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+
+*/
+
+#include "orxonox_gui_keys.h"
+#include <iostream.h>
+
+/**
+   \brief Creates an Keyboard-Frame
+*/
+OrxonoxGuiKeys::OrxonoxGuiKeys ()
+{
+  keysFrame = new Frame ("Keyboard-Options:");
+  keysFrame->setGroupName("Keyboard");
+  keysBox = new Box ('v');
+  player1 = new Player("player1");
+  player2 = new Player("player2");
+  
+  keysBox->fill(player1->getOpenButton());
+
+  keysFrame->fill (keysBox);
+}
+
+/**
+   \brief Return the Frame
+   \return Returns the Audio-frame
+*/
+Widget* OrxonoxGuiKeys::getWidget ()
+{
+  return keysFrame;
+}
+
+
+
+/* PLAYER */
+Player::Player(char* player)
+{
+  openButton = new Button (player);
+}
+
+Button* Player::getOpenButton()
+{
+  return openButton;
+}
+
+
+void Player::setkey(KEYS key)
+{
+  cout << "setting up Key: "<< key <<endl;
+}
+
+gint WindowOpen (GtkWidget* widget, GdkEvent* event, void* player)
+{
+  
+}
+
Index: orxonox/branches/buerli/gui/orxonox_gui_keys.h
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_keys.h	(revision 2707)
+++ orxonox/branches/buerli/gui/orxonox_gui_keys.h	(revision 2707)
@@ -0,0 +1,55 @@
+/*!
+  \file orxonox_gui_keys.h
+  \brief File that holds the class that creates the Keyboard-Options.
+*/
+
+#ifndef _ORXONOX_GUI_KEYS_H
+#define _ORXONOX_GUI_KEYS_H
+
+#include "orxonox_gui.h"
+
+/**
+ * defines the Possible Player Keys
+ */
+enum KEYS { UP, DOWN, LEFT, RIGTH, SHOOT };
+
+/**
+   \brief Class to hold infos about a Player
+*/
+class Player
+{
+ private:
+  char keys[10];
+  Button* openButton;
+  Window* window;
+  
+ public:
+  Player(char* player);
+
+  Button* getOpenButton();
+
+  void setkey(KEYS key);
+  
+};
+
+//! Class that creates the Keys-Options.
+class OrxonoxGuiKeys
+{
+ private:
+  Frame* keysFrame;
+  Box* keysBox;
+  Player* player1;
+  Player* player2;
+  Button* misc;
+
+ public:
+  OrxonoxGuiKeys ();
+  ~OrxonoxGuiKeys ();
+  
+  Widget* getWidget ();
+};
+
+
+    
+
+#endif /* _ORXONOX_GUI_KEYS_H */
Index: orxonox/branches/buerli/gui/orxonox_gui_video.cc
===================================================================
--- orxonox/branches/buerli/gui/orxonox_gui_video.cc	(revision 2706)
+++ orxonox/branches/buerli/gui/orxonox_gui_video.cc	(revision 2707)
@@ -32,4 +32,5 @@
   videoFrame = new Frame ("Video-Options:");
   videoBox = new Box ('v');
+  videoFrame->setGroupName("video");
   
   fullscreen = new CheckButton ("Fullscreen-mode");
Index: orxonox/branches/buerli/src/camera.cc
===================================================================
--- orxonox/branches/buerli/src/camera.cc	(revision 2706)
+++ orxonox/branches/buerli/src/camera.cc	(revision 2707)
@@ -27,6 +27,7 @@
    This standard constructor sets all parameters to zero
 */
-Camera::Camera ()
-{
+Camera::Camera (World* world)
+{
+  this->world = world;
   bound = NULL;
   /* give it some physical live */
@@ -36,5 +37,4 @@
   fs = new Vector(0.0, 0.0, 0.0);
   cameraMode = NORMAL;
-
   deltaTime = 3000.0;
   cameraOffset = 1.0;
@@ -179,10 +179,9 @@
       /* the camera is handled like an entity and rolls on the track */
     case NORMAL:
-      Orxonox *orx = Orxonox::getInstance();
       Location lookat;  
-      if( bound != NULL)
+      if( bound != NULL && world != NULL )
 	{
 	  bound->get_lookat (&lookat);
-	  orx->get_world()->calc_camera_pos (&lookat, &desired_place);
+	  world->calc_camera_pos (&lookat, &desired_place);
 	} 
       else
@@ -293,2 +292,8 @@
     } 
 }
+
+
+void Camera::setWorld(World* world)
+{
+  this->world = world;
+}
Index: orxonox/branches/buerli/src/camera.h
===================================================================
--- orxonox/branches/buerli/src/camera.h	(revision 2706)
+++ orxonox/branches/buerli/src/camera.h	(revision 2707)
@@ -10,12 +10,13 @@
 
 class WorldEntity;
+class World;
 
 //! Camera
 /**
- 	This class controls the viewpoint from which the World is rendered. To use the 
-	Camera it has to be bound to a WorldEntity which serves as the reference focus 
-	point. The Camera itself calls the WorldEntity::get_lookat() and 
-	World::calc_camera_pos() functions to calculate the position it currently should
-	be in.
+   This class controls the viewpoint from which the World is rendered. To use the 
+   Camera it has to be bound to a WorldEntity which serves as the reference focus 
+   point. The Camera itself calls the WorldEntity::get_lookat() and 
+   World::calc_camera_pos() functions to calculate the position it currently should
+   be in.
 */
 
@@ -27,4 +28,5 @@
   Placement actual_place;	        //!< the Camera's current position
   Placement desired_place;        //!< where the Camera should be according to calculations
+  World* world;
   
   /* physical system - not needed yet */
@@ -49,17 +51,19 @@
   Quaternion *res;
   
+  
+  CAMERA_MODE cameraMode; //!< saves the camera mode: how the camera follows the entity
+  
+  void update_desired_place ();
+  
+ public:
+  Camera (World* world);
+  ~Camera ();
+  
+  void time_slice (Uint32 deltaT);
+  void apply ();
+  void bind (WorldEntity* entity);
+  void jump (Placement* plc);
 
-  CAMERA_MODE cameraMode; //!< saves the camera mode: how the camera follows the entity
-
-	void update_desired_place ();
-	
- public:
-  Camera ();
-  ~Camera ();
-
-	void time_slice (Uint32 deltaT);
-	void apply ();
-	void bind (WorldEntity* entity);
-	void jump (Placement* plc);
+  void setWorld(World* world);  
 
 };
Index: orxonox/branches/buerli/src/campaign.cc
===================================================================
--- orxonox/branches/buerli/src/campaign.cc	(revision 2707)
+++ orxonox/branches/buerli/src/campaign.cc	(revision 2707)
@@ -0,0 +1,157 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: 
+*/
+
+
+#include "campaign.h"
+#include "world.h"
+#include "camera.h"
+#include "story_entity.h"
+
+using namespace std;
+
+
+Campaign::Campaign () 
+{
+  this->entities = new List<StoryEntity>();
+  this->isInit = false;
+}
+
+Campaign::~Campaign () {}
+
+
+Error Campaign::init()
+{
+  this->isInit = true;
+}
+
+/** 
+    \brief adds an game stroy entity to the campaign
+
+    \param se: The entity
+    \param storyID: The number that identifies the entity in the campaign. Each ID only used once in a Campaign
+
+    An entity can be a world (playable), a cinematic, a shop, sounds, whatever you
+    want to queue up in the campaign.
+*/
+void Campaign::addEntity(StoryEntity* se, Uint32 storyID)
+{
+  se->setStoryID(storyID);
+  this->addEntity(se);
+}
+
+void Campaign::addEntity(StoryEntity* se)
+{
+  this->entities->add(se);
+}
+
+
+void Campaign::removeEntity(Uint32 storyID)
+{
+  this->removeEntity(this->getStoryEntity(storyID));
+  
+}
+
+
+void Campaign::removeEntity(StoryEntity* se)
+{
+  this->entities->remove(se);
+}
+
+
+Error Campaign::start()
+{
+  this->start(0);
+}
+
+Error Campaign::start(Uint32 storyID = 0)
+{
+  printf("World::start() - starting new StoryEntity Nr:%i\n", storyID);
+  Error errorCode;
+  if(!this->isInit) return errorCode; 
+  if(storyID == WORLD_ID_GAMEEND) return errorCode;
+  this->running = true;
+  StoryEntity* se = this->getStoryEntity(storyID);
+  while(se != NULL && this->running)
+    {
+      se = this->getStoryEntity(storyID);
+      this->currentEntity = se;
+      
+      se->displayEntityScreen();
+      se->load();
+      se->init();
+      se->releaseEntityScreen();
+      se->start();
+
+      int nextWorldID = se->getNextStoryID();
+      if(nextWorldID == WORLD_ID_GAMEEND) return errorCode;
+      se = this->getStoryEntity(nextWorldID);
+      if(se == NULL)
+	printf("Campaign::start() - ERROR: world it not found, oh oh...");
+    }
+}
+
+Error Campaign::stop()
+{
+  this->running = false;
+  if(this->currentEntity != NULL) 
+    {
+      this->currentEntity->stop();
+      delete this->currentEntity;
+      this->currentEntity = NULL;
+    }
+}
+
+Error Campaign::pause()
+{
+  if(this->currentEntity != NULL)
+    this->isPaused = true;
+}
+
+
+Error Campaign::resume()
+{
+  if(this->currentEntity != NULL)
+    this->isPaused = false;
+}
+
+
+void Campaign::nextLevel()
+{
+  printf("Campaign|nextLevel\n");
+  int nextID = this->currentEntity->getNextStoryID();
+  this->stop();
+  this->start(nextID);
+}
+
+void Campaign::previousLevel()
+{}
+
+
+StoryEntity* Campaign::getStoryEntity(Uint32 storyID)
+{
+  List<StoryEntity>* l;
+  StoryEntity* entity;
+  l = this->entities->get_next();  
+  while( l != NULL) 
+    { 
+      entity = l->get_object();
+      l = l->get_next();
+      if(entity->getStoryID() == storyID)
+	return entity;
+    }
+  return NULL;
+}
Index: orxonox/branches/buerli/src/campaign.h
===================================================================
--- orxonox/branches/buerli/src/campaign.h	(revision 2707)
+++ orxonox/branches/buerli/src/campaign.h	(revision 2707)
@@ -0,0 +1,41 @@
+
+#ifndef CAMPAIGN_H
+#define CAMPAIGN_H
+
+#include "stdincl.h"
+#include "story_entity.h"
+
+
+class World;
+
+class Campaign : public StoryEntity {
+
+ public:
+  Campaign ();
+  ~Campaign ();
+
+  StoryEntity* currentEntity;
+
+  virtual Error init();
+  virtual Error start();
+  virtual Error start(Uint32 storyID);
+  virtual Error stop();
+  virtual Error pause();
+  virtual Error resume();
+
+  void addEntity(StoryEntity* se, Uint32 storyID);
+  void addEntity(StoryEntity* se);
+  void removeEntity(Uint32 storyID);
+  void removeEntity(StoryEntity* se);
+  
+  void nextLevel();
+  void previousLevel();
+
+ private:
+  List<StoryEntity>* entities;
+  bool running;
+
+  StoryEntity* getStoryEntity(Uint32 storyID);
+};
+
+#endif
Index: orxonox/branches/buerli/src/command_node.cc
===================================================================
--- orxonox/branches/buerli/src/command_node.cc	(revision 2706)
+++ orxonox/branches/buerli/src/command_node.cc	(revision 2707)
@@ -19,4 +19,5 @@
 #include "ini_parser.h"
 #include "world_entity.h"
+#include "game_loader.h"
 
 #include <stdio.h>
@@ -27,187 +28,188 @@
 
 /**
-	\brief constructs a CommandNode to handle remote input
-	\param ID: unique denumerator to identify the node in the network
+   \brief constructs a CommandNode to handle remote input
+   \param ID: unique denumerator to identify the node in the network
 */
 CommandNode::CommandNode (int ID)
 {
-	bound = new List<WorldEntity>();
-	aliases = NULL;
-	netID = ID;
-	bLocalInput = false;
-}
-
-/**
-	\brief constructs a CommandNode to handle local input
-	\param filename: The path and name of the file to load the key bindings from
+  bound = new List<WorldEntity>();
+  aliases = NULL;
+  netID = ID;
+  bLocalInput = false;
+}
+
+/**
+   \brief constructs a CommandNode to handle local input
+   \param filename: The path and name of the file to load the key bindings from
 */
 CommandNode::CommandNode (char* filename = DEFAULT_KEYBIND_FILE)
 {
-	aliases = NULL;
-	bLocalInput = true;
-	netID = 0;
-	bound = new List<WorldEntity>();
-	load_bindings (filename);
-}
-
-/**
-	\brief removes the CommandNode from memory
+  aliases = NULL;
+  bLocalInput = true;
+  netID = 0;
+  bound = new List<WorldEntity>();
+  load_bindings (filename);
+}
+
+/**
+   \brief removes the CommandNode from memory
 */
 CommandNode::~CommandNode ()
 {
-	if( aliases != NULL) free (aliases);
-	if( bound != NULL) delete bound;
-}
-
-/**
-	\brief loads new key bindings from a file
-	\param filename: The path and name of the file to load the bindings from
+  if( aliases != NULL) free (aliases);
+  if( bound != NULL) delete bound;
+}
+
+/**
+   \brief loads new key bindings from a file
+   \param filename: The path and name of the file to load the bindings from
 */
 void CommandNode::load_bindings (char* filename)
 {
-	FILE* stream;
-	
-	printf("Loading key bindings from %s\n", filename);
-	
-	if( filename == NULL) filename = DEFAULT_KEYBIND_FILE;
-	
-		// remove old bindings if present
-	if( aliases != NULL)
+  FILE* stream;
+  
+  printf("Loading key bindings from %s\n", filename);
+  
+  if( filename == NULL) filename = DEFAULT_KEYBIND_FILE;
+  
+  // remove old bindings if present
+  if( aliases != NULL)
+    {
+      free (aliases);
+      aliases = NULL;
+    }
+  
+  // create parser
+  IniParser parser (filename);
+  if( parser.get_section ("Bindings") == -1)
+    {
+      printf("Could not find key bindings in %s\n", filename);
+      return;
+    }
+  // allocate empty lookup table
+  aliases = (KeyBindings*) calloc (1, sizeof (KeyBindings));
+  
+  char namebuf[256];
+  char valuebuf[256];
+  memset (namebuf, 0, 256);
+  memset (valuebuf, 0, 256);
+  int* index;
+  
+  while( parser.next_var (namebuf, valuebuf) != -1)
+    {
+      index = name_to_index (namebuf);
+      switch( index[0])
 	{
-		free (aliases);
-		aliases = NULL;
+	case 0:
+	  printf("Key binding %d(%s) set to %s\n", index[1], SDLK_to_keyname( index[1]), valuebuf);
+	  strcpy (aliases->keys[index[1]], valuebuf);
+	  break;
+	case 1:
+	  printf("Button binding %d(%s) set to %s\n", index[1], SDLB_to_buttonname( index[1]), valuebuf);
+	  strcpy (aliases->buttons[index[1]], valuebuf);
+	  break;
+	default:
+	  break;
 	}
-			
-		// create parser
-	IniParser parser (filename);
-	if( parser.get_section ("Bindings") == -1)
+      memset (namebuf, 0, 256);
+      memset (valuebuf, 0, 256);
+    }
+}
+
+/**
+   \brief binds a WorldEntity to the CommandNode
+   \param entity: Pointer to the entity to bind
+*/
+void CommandNode::bind (WorldEntity* entity)
+{
+  bound->add (entity, LIST_ADD_NEXT, true);
+}
+
+/**
+   \brief removes an entity from the list of the CommandNode
+   \param entity: Pointer to the entity to relese
+*/
+void CommandNode::unbind (WorldEntity* entity)
+{
+  bound->remove (entity, LIST_FIND_FW);
+}
+
+int* CommandNode::name_to_index (char* name)
+{
+  coord[0] = -1;
+  coord[1] = -1;
+  int c;
+  if( (c = keyname_to_SDLK (name)) != -1)
+    {
+      coord[1] = c;
+      coord[0] = 0;
+    }
+  if( (c = buttonname_to_SDLB (name)) != -1)
+    {
+      coord[1] = c;
+      coord[0] = 1;
+    }
+  return coord;
+}
+
+/**
+   \brief tells the CommandNode to run through all pending events and relay them accordingly
+*/
+void CommandNode::process ()
+{
+  if( bLocalInput) process_local ();
+  else process_network ();
+}
+
+void CommandNode::process_local ()
+{
+  SDL_Event event;
+  Command cmd;
+  
+  while( SDL_PollEvent (&event))
+    {
+      memset (cmd.cmd, 0, CMD_LENGHT); 
+      switch( event.type)
 	{
-		printf("Could not find key bindings in %s\n", filename);
-		return;
+	case SDL_KEYDOWN:
+	  strcpy (cmd.cmd, aliases->keys[event.key.keysym.sym]);
+	  cmd.bUp = false;
+	  if( strlen (cmd.cmd) > 0) relay (&cmd);
+	  break;
+	case SDL_KEYUP:
+	  strcpy( cmd.cmd, aliases->keys[event.key.keysym.sym]);
+	  cmd.bUp = true;
+	  if( strlen (cmd.cmd) > 0) relay (&cmd);
+	  break;
+	case SDL_MOUSEMOTION:
+	  strcpy( cmd.cmd, "cursor");
+	  cmd.x = event.motion.x;
+	  cmd.y = event.motion.y;
+	  cmd.xrel = event.motion.xrel;
+	  cmd.yrel = event.motion.yrel;
+	  break;
+	case SDL_MOUSEBUTTONUP:
+	  strcpy( cmd.cmd, aliases->buttons[event.button.button]);
+	  cmd.bUp = true;
+	  if( strlen (cmd.cmd) > 0) relay (&cmd);
+	  break;
+	case SDL_MOUSEBUTTONDOWN:
+	  strcpy( cmd.cmd, aliases->buttons[event.button.button]);
+	  cmd.bUp = false;
+	  if( strlen (cmd.cmd) > 0) relay (&cmd);
+	  break;
+	case SDL_JOYAXISMOTION:
+	case SDL_JOYBALLMOTION:
+	case SDL_JOYHATMOTION:
+	case SDL_JOYBUTTONDOWN:
+	case SDL_JOYBUTTONUP:
+	  break;
+	default:
+	  Orxonox *orx = Orxonox::getInstance();
+	  orx->event_handler (&event);
+	  
+	  break;
 	}
-			// allocate empty lookup table
-	aliases = (KeyBindings*) calloc (1, sizeof (KeyBindings));
-	
-	char namebuf[256];
-	char valuebuf[256];
-	memset (namebuf, 0, 256);
-	memset (valuebuf, 0, 256);
-	int* index;
-
-	while( parser.next_var (namebuf, valuebuf) != -1)
-	{
-		index = name_to_index (namebuf);
-		switch( index[0])
-		{
-			case 0:
-				printf("Key binding %d(%s) set to %s\n", index[1], SDLK_to_keyname( index[1]), valuebuf);
-				strcpy (aliases->keys[index[1]], valuebuf);
-				break;
-			case 1:
-				printf("Button binding %d(%s) set to %s\n", index[1], SDLB_to_buttonname( index[1]), valuebuf);
-				strcpy (aliases->buttons[index[1]], valuebuf);
-				break;
-			default:
-				break;
-		}
-		memset (namebuf, 0, 256);
-		memset (valuebuf, 0, 256);
-	}
-}
-
-/**
-	\brief binds a WorldEntity to the CommandNode
-	\param entity: Pointer to the entity to bind
-*/
-void CommandNode::bind (WorldEntity* entity)
-{
-	bound->add (entity, LIST_ADD_NEXT, true);
-}
-
-/**
-	\brief removes an entity from the list of the CommandNode
-	\param entity: Pointer to the entity to relese
-*/
-void CommandNode::unbind (WorldEntity* entity)
-{
-	bound->remove (entity, LIST_FIND_FW);
-}
-
-int* CommandNode::name_to_index (char* name)
-{
-	coord[0] = -1;
-	coord[1] = -1;
-	int c;
-	if( (c = keyname_to_SDLK (name)) != -1)
-	{
-		coord[1] = c;
-		coord[0] = 0;
-	}
-	if( (c = buttonname_to_SDLB (name)) != -1)
-	{
-		coord[1] = c;
-		coord[0] = 1;
-	}
-	return coord;
-}
-
-/**
-	\brief tells the CommandNode to run through all pending events and relay them accordingly
-*/
-void CommandNode::process ()
-{
-	if( bLocalInput) process_local ();
-	else process_network ();
-}
-
-void CommandNode::process_local ()
-{
-	SDL_Event event;
-	Command cmd;
-	
-	while( SDL_PollEvent (&event))
-	{
-		memset (cmd.cmd, 0, CMD_LENGHT); 
-		switch( event.type)
-		{
-			case SDL_KEYDOWN:
-				strcpy (cmd.cmd, aliases->keys[event.key.keysym.sym]);
-				cmd.bUp = false;
-				if( strlen (cmd.cmd) > 0) relay (&cmd);
-				break;
-			case SDL_KEYUP:
-				strcpy( cmd.cmd, aliases->keys[event.key.keysym.sym]);
-				cmd.bUp = true;
-				if( strlen (cmd.cmd) > 0) relay (&cmd);
-				break;
-			case SDL_MOUSEMOTION:
-				strcpy( cmd.cmd, "cursor");
-				cmd.x = event.motion.x;
-				cmd.y = event.motion.y;
-				cmd.xrel = event.motion.xrel;
-				cmd.yrel = event.motion.yrel;
-				break;
-			case SDL_MOUSEBUTTONUP:
-				strcpy( cmd.cmd, aliases->buttons[event.button.button]);
-				cmd.bUp = true;
-				if( strlen (cmd.cmd) > 0) relay (&cmd);
-				break;
-			case SDL_MOUSEBUTTONDOWN:
-				strcpy( cmd.cmd, aliases->buttons[event.button.button]);
-				cmd.bUp = false;
-				if( strlen (cmd.cmd) > 0) relay (&cmd);
-				break;
-			case SDL_JOYAXISMOTION:
-			case SDL_JOYBALLMOTION:
-			case SDL_JOYHATMOTION:
-			case SDL_JOYBUTTONDOWN:
-			case SDL_JOYBUTTONUP:
-				break;
-			default:
-  				Orxonox *orx = Orxonox::getInstance();
-  				orx->event_handler (&event);
-				break;
-		}
-	}
+    }
 }
 
@@ -219,25 +221,27 @@
 void CommandNode::relay (Command* cmd)
 {
-printf("CommandNode|relay()\n");
-	List<WorldEntity>* plist = bound;
-	
-	Orxonox *orx = Orxonox::getInstance();
-	if( orx->system_command (cmd)) return;
-		
-	if( bLocalInput) send_over_network (cmd);
-	
-	while( (plist = plist->get_next()) != NULL)
-	{
-		plist->get_object()->command (cmd);
-	}
-}
-
-/**
-	\brief sets the network identifier of the CommandNode
-	\param ID: the new ID to use
+  //printf("CommandNode|relay()\n");
+  List<WorldEntity>* plist = bound;
+  
+  Orxonox *orx = Orxonox::getInstance();
+  if( orx->system_command (cmd)) return;
+  GameLoader* gl = GameLoader::getInstance();
+  if(gl->worldCommand(cmd)) return;
+  
+  if( bLocalInput) send_over_network (cmd);
+  
+  while( (plist = plist->get_next()) != NULL)
+    {
+      plist->get_object()->command (cmd);
+    }
+}
+
+/**
+   \brief sets the network identifier of the CommandNode
+   \param ID: the new ID to use
 */
 void CommandNode::set_netID (int ID)
 {
-	netID = ID;
+  netID = ID;
 }
 
Index: orxonox/branches/buerli/src/error.h
===================================================================
--- orxonox/branches/buerli/src/error.h	(revision 2706)
+++ orxonox/branches/buerli/src/error.h	(revision 2707)
@@ -22,5 +22,35 @@
 */ 
 
+// this are the two undefined error nr. Don't use them ...
+#define ERROR -1
+#define NERROR 0
 
-#define ERROR -1
-#define NO_ERROR 0
+/*!
+    \brief Error Definitions:
+
+    Error Classes:
+    0xx application framework codes
+    1xx graphics codes
+    2xx file/FS codes
+    3xx network codes
+    4xx general codes
+
+    Error Specifier 1:
+    x0x action finsished as desired
+    x1x initialisation error
+    x2x execution error
+    x3x uninitialisation error
+
+    Error Specifier 2:
+    xx0 no further informations
+    xx1 only a warning - feel free to ignore, the program will proceed
+    xx2 this could lead unexpected behaviour
+    xx3 this is a fatal error - you are invited to quit the program - panic!
+*/
+
+typedef struct 
+{
+  int code;
+  char* message;
+  char* location;
+} Error;
